#include <stdio.h>
#include <windows.h>

#define BLACK 0
#define BLUE 1
#define GREEN 2
#define CYAN 3
#define RED 4
#define MAGENTA 5
#define BROWN 6
#define LIGHTGREY 7
#define DARKGREY 8
#define LIGHTBLUE 9
#define LIGHTGREEN 10
#define LIGHTCYAN 11
#define LIGHTRED 12
#define LIGHTMAGENTA 13
#define YELLOW 14
#define WHITE 15
#define BLINK 128

#define PI 3.14159265

HANDLE hOut;

int glowingHour,glowingMinute,glowingSec,x=-20,y=-20,oldm=-20,oldh=-20;
double result, result2;
COORD xy,start;

void TextColor(int iFront,int iBack)
{
    int iColor;
    iColor = iBack;
    iColor = _rotl(iColor,4) | iFront;
    SetConsoleTextAttribute(hOut,iColor);
}//void textColor

int minRound(int getal,int interval){
     if (interval != 5){ return getal; }
     float getal2 = (int)getal / 5.0;
     getal = round(getal2) * interval;
     if (getal == 60){ getal = 0; }
     return getal;
}

void drawClock(int r, int interval, int spread, int low, int colorF, int colorB, int midX, int midY, int no,int colorX,int colorZ,int type,int oldNo){
     COORD xy;
     if (no == -1){
         int param = 360 / (spread/interval) - 60;
         if (interval == 5) {param-=30;}
         TextColor(colorF,colorB);
         int i;
         for (i = interval; i <= spread; i += interval){
               result = cos (param * PI/180), result2 = sin (param *PI/180);
               x = result * r + midX, y = result2 * r + midY; //Midden is normaal x38,y10
               if (y <= 0){y = y - 1;}
               xy.X = x;
               xy.Y = y / 1.5 + 5;
               SetConsoleCursorPosition(hOut, xy);
               printf("%d\n",i%spread + low);
               param += 30;
         }//for i
     }// end type 0
     else {
          TextColor(colorX,colorZ);
          int param = 360 / (spread/interval) - 90 + 30 * (no/interval);
          if (type == 2){param -= 30;}
          if (interval == 5) {param-=30;}
          result = cos (param * PI/180), result2 = sin (param *PI/180);
          x = result * r + midX, y = result2 * r + midY; //Midden is normaal x38,y10
          if (y <= 0){y = y - 1;}
          if (no == 0 || type == 2 && no == 1){x = x - 1;}
          xy.X = x;
          xy.Y = y / 1.5 + 5;
          SetConsoleCursorPosition(hOut, xy);
          printf("%d\n",no);
          if (oldNo != no && oldNo != -20){ //maak oude nummer rood
              TextColor(colorF,colorB);
              int param = 360 / (spread/interval) - 90 + 30 * (oldNo/interval);
              if (type == 2){param -= 30;}
              if (interval == 5) {param-=30;}
              result = cos (param * PI/180), result2 = sin (param *PI/180);
              x = result * r + midX, y = result2 * r + midY; //Midden is normaal x38,y10
              if (y <= 0){y = y - 1;}
              if (no == 0){x = x - 1;}
              xy.X = x;
              xy.Y = y / 1.5 + 5;
              SetConsoleCursorPosition(hOut, xy);
              printf("%d\n",oldNo);
          }//if, oude nummer rood tekenen
     }//if/else type check
}//void drawClock

int main(){
    CONSOLE_CURSOR_INFO cciCursorOff = {0};
    hOut = GetStdHandle(STD_OUTPUT_HANDLE);
    cciCursorOff.dwSize = 30; 
    cciCursorOff.bVisible = FALSE;
    SetConsoleCursorInfo (hOut, &cciCursorOff);
    
    time_t timer;
    timer=time(NULL);
    SYSTEMTIME str_t;
    
    int timeZone = 1;
    int r = 15;
    drawClock(r,1,12,1,LIGHTRED,BLACK,38,10,-1,LIGHTRED,BLACK,1,-1);
    drawClock(r-3,5,60,0,RED,BLACK,38,10,-1,RED,BLACK,1,-1); 
    start.X = 38;//38
    start.Y = 10;//10
    char action;

    while (1){
          GetSystemTime(&str_t);
          glowingSec = str_t.wSecond;
          SetConsoleCursorPosition(hOut, start);
          if (glowingSec < 10){
                         printf("0%d",glowingSec);}
          else{
               printf("%d",glowingSec);}
          glowingMinute = minRound(str_t.wMinute,5);
          glowingHour = (str_t.wHour + timeZone)%12;
          if (!glowingHour){glowingHour = 12;}
          drawClock(r,1,12,1,LIGHTRED,BLACK,38,10,glowingHour,LIGHTGREEN,BLACK,2,oldh);  
          oldh = glowingHour;
          drawClock(r-3,5,60,0,RED,BLACK,38,10,glowingMinute,GREEN,BLACK,3,oldm);
          oldm = glowingMinute;
          /*action = getch();
          if (action == 61 || action == 43){
             r++;
             action = 0;  
             system("cls");       
             drawClock(r,1,12,1,LIGHTRED,BLACK,38,10,-1,LIGHTRED,BLACK,1,-1);
             drawClock(r-3,5,60,0,RED,BLACK,38,10,-1,RED,BLACK,1,-1);   
          }
          if (action ==45 || action == 95 && r > 5){
             r--;     
             action = 0; 
             system("cls");    
             drawClock(r,1,12,1,LIGHTRED,BLACK,38,10,-1,LIGHTRED,BLACK,1,-1);
             drawClock(r-3,5,60,0,RED,BLACK,38,10,-1,RED,BLACK,1,-1);      
          }*/
    }//klok loop
}//int main
