#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <windows.h>
#include <string.h>
#include <time.h>
#include <dos.h>
#include <mmsystem.h>
#include <iostream>

#define BLACK 0
#define BLUE 1
#define GREEN 2
#define CYAN 3
#define RED 4
#define MAGENTA 5
#define BROWN 6
#define LIGHTGREY 7
#define DARKGREY 8
#define LIGHTBLUE 9
#define LIGHTGREEN 10
#define LIGHTCYAN 11
#define LIGHTRED 12
#define LIGHTMAGENTA 13
#define YELLOW 14
#define WHITE 15
#define BLINK 128
HANDLE hOut;

void TextColor(int iFront,int iBack)
{
    int iColor;
    iColor = iBack;
    iColor = _rotl(iColor,4) | iFront;
    SetConsoleTextAttribute(hOut,iColor);
}

void printpos(COORD co, char *cText) {
    SetConsoleCursorPosition(hOut, co);
    WriteConsoleA(hOut,cText,strlen(cText), NULL, NULL);
}

void cprintxy(int x, int y, char cText) {
    COORD co;
    char cString[2];
    cString[0]=cText;
    cString[1]=0;
    //sprintf(cString, "%c", cText);
    co.X=x; co.Y=y;
    printpos(co, cString);
}

void timeM(int caseM);
void timeH(int caseH);
void coTime(int hour);
void draw(int no, int type);
void time();

int main ()
{
int end = 0;
COORD coPos, coAlarm, coMid;
    
    coPos.Y = 0;
    coPos.X = 0;
    coAlarm.Y = 0;
    coAlarm.X = 55;
    coMid.Y = 10;
    coMid.X = 35;
    
    
    
    CONSOLE_CURSOR_INFO cciCursorOff = {0};

    hOut = GetStdHandle(STD_OUTPUT_HANDLE);
    cciCursorOff.dwSize = 30; 
    cciCursorOff.bVisible = FALSE;
    SetConsoleCursorInfo (hOut, &cciCursorOff);
while (end == 0)
{
    
    int alarmHour = 26;
    int alarmMin = 62;
    int timeZone = -503;
    int valid = 0;
    while (timeZone == -503){
    printpos(coPos,"Please enter a time zone in GMT: ");
    scanf(" %d", &timeZone);
    getchar();
    system("cls");
    if (timeZone == -503) {
       printf("The timezone you entered is invalid\nPlease enter a valid timezone.\nExample: 2 or -3\n\nPress a key to continue."); 
       getch();
       timeZone = -503;
       system("cls");
    }
    }
    printpos(coPos,"Would you like to set an alarm? (Y/N)");
    while (valid == 0) {
        int keyPress = getch();
        system("cls");
        if (keyPress == 121 || keyPress == 89){
            printpos(coPos,"Please enter the alarm hour value in 24hour format: ");
            scanf("%d", &alarmHour);
            system("cls");
            printpos(coPos,"Please enter the alarm minute value: ");
            scanf("%d", &alarmMin);
            system("cls");
            printf("The alarm has been set to %d:%d\nPress enter to continue",alarmHour,alarmMin);
            getchar();
            getchar();
            system("cls");
            if (alarmHour < 25 && alarmMin < 60 && alarmHour > -1 && alarmMin > -1) {
               valid = 1;
            }
            else {
                 system("cls");
                 printpos(coPos,"The alarm you've set is invalid.\nDo you want to set an alarm? (Y/N)");
                 alarmHour = 26;
                 alarmMin = 26;
            }
        }
        else if (keyPress == 110 || keyPress == 78){
             valid = 2;
        }
        else { valid = 0; 
        system("cls");
                 printpos(coPos,"Invalid key.\nDo you want to set an alarm? (Y/N)");}
    }
    
    int secCheck;
    int minCheck;
    int loop = 1;
    
   
    while (loop != 0) {
          time_t timer;

          timer=time(NULL);
            
          SYSTEMTIME str_t;
          GetSystemTime(&str_t);
            
          int glowingHour = str_t.wHour + timeZone;
          int fullHour = str_t.wHour + timeZone;
          while (glowingHour > 12 || glowingHour < -12 || fullHour > 23 || fullHour < 0){
          if (glowingHour > 12) 
            {
               glowingHour = glowingHour - 12; 
            }
          else if (glowingHour < -12)
          {
               glowingHour = glowingHour + 12;
          }
          if (fullHour > 23) {
             fullHour = fullHour - 24;   
          }
          else if (fullHour < 0) {
             fullHour = fullHour + 24;
          }
          }
            int glowingMinute = str_t.wMinute;
            int glowingSecond = str_t.wSecond;
            
            TextColor(RED, BLACK);
            
          if (glowingMinute != minCheck ) {
             system("cls");
             
             time_t timer;

          timer=time(NULL);
            
          SYSTEMTIME str_t;
          GetSystemTime(&str_t);
            
          int glowingHour = str_t.wHour + timeZone;
          int fullHour = str_t.wHour + timeZone;
          while (glowingHour > 12 || glowingHour < -12 || fullHour > 23 || fullHour < 0){
          if (glowingHour > 12) 
            {
               glowingHour = glowingHour - 12; 
            }
          else if (glowingHour < -12)
          {
               glowingHour = glowingHour + 12;
          }
          if (fullHour > 23) {
             fullHour = fullHour - 24;   
          }
          else if (fullHour < 0) {
             fullHour = fullHour + 24;
          }
          }
            int glowingMinute = str_t.wMinute;
            int glowingSecond = str_t.wSecond;
            
             TextColor(BLUE, BLACK);
             draw(glowingMinute, 2);
             TextColor(BLUE, BLACK);
             draw(glowingHour, 1);
             TextColor(RED, BLACK);
             timeM(glowingMinute);
             timeH(glowingHour);
             
             SetConsoleCursorPosition(hOut, coAlarm);
            TextColor(CYAN, BLACK);
            if (valid == 1) {
            printf("Alarm goes on at %d:%d",alarmHour,alarmMin);
            }
            else {
            printf("Alarm isn't set");
            }
          }
            
          if (glowingSecond != secCheck) {
            TextColor(WHITE,BLACK);
            
            secCheck = glowingSecond;
            minCheck = glowingMinute;
            
        
            //printf("The current time is %s\n",asctime(localtime(&timer)));
            
        	COORD coCursor = {0,0};
            SetConsoleCursorPosition(hOut, coCursor);
            printf("Hour: %d   Minute: %d   Second: %d  ", fullHour, glowingMinute, glowingSecond);
            
            
          }
          
          TextColor(CYAN, BLACK);
          printpos(coMid,"*");
          TextColor(RED, BLACK);
          
          TextColor(BLACK, LIGHTBLUE);
          if (alarmHour == fullHour && alarmMin == glowingMinute && valid == 1)
          {
             system("cls");
             PlaySound(TEXT("alarm.wav"), NULL, SND_FILENAME | SND_LOOP | SND_ASYNC);
             printf("                                                                      \n");
             printf("                                                                      \n");
             printf("                                                                      \n");
             printf("                                                                      \n");
             printf("                                                                      \n");
             printf("                               ALARM                                  \n");
             printf("                                                                      \n");
             printf("                                                                      \n");
             printf("                                                                      \n");
             printf("                                                                      \n");
             printf("                                                                      \n");
             loop = 0;
          }
    }
    getch();
    PlaySound(NULL, 0, 0);
    TextColor(WHITE,BLACK);
    system("cls");
}
return 0;
}

void timeM(int caseM) {
    COORD coTimeM0,coTimeM5,coTimeM10,coTimeM15,coTimeM20,coTimeM25,coTimeM30,coTimeM35,coTimeM40,coTimeM45,coTimeM50,coTimeM55;
    coTimeM0.Y = 4; // 12
    coTimeM0.X = 35; 
    
    coTimeM5.Y = 5; // 1
    coTimeM5.X = 40; 
    
    coTimeM10.Y = 7; // 2
    coTimeM10.X = 43; 
    coTimeM15.Y = 10; // 3
    coTimeM15.X = 45;
    coTimeM20.Y = 13; // 4
    coTimeM20.X = 43;
    coTimeM25.Y = 15; // 5
    coTimeM25.X = 40;
    coTimeM30.Y = 16;
    coTimeM30.X = 35;
    coTimeM35.Y = 15;
    coTimeM35.X = 29u;
    coTimeM40.Y = 13;
    coTimeM40.X = 25;
    coTimeM45.Y = 10;
    coTimeM45.X = 24;
    coTimeM50.Y = 7;
    coTimeM50.X = 27;
    coTimeM55.Y = 5;
    coTimeM55.X = 30;
    
    printpos(coTimeM0,"0");
    printpos(coTimeM5,"5");
    printpos(coTimeM10,"10");
    printpos(coTimeM15,"15");
    printpos(coTimeM20,"20");
    printpos(coTimeM25,"25");
    printpos(coTimeM30,"30");
    printpos(coTimeM35,"35");
    printpos(coTimeM40,"40");
    printpos(coTimeM45,"45");
    printpos(coTimeM50,"50");
    printpos(coTimeM55,"55");
    
     if (caseM > 57 || caseM < 3) {
             TextColor(GREEN,BLACK);       
             printpos(coTimeM0,"0");
     }
     else if (caseM > 2 && caseM < 8) {
             TextColor(GREEN,BLACK);
             printpos(coTimeM5,"5");
     }
     else if (caseM > 7 && caseM < 13) {
             TextColor(GREEN,BLACK);
             printpos(coTimeM10,"10");
     }
     else if (caseM > 12 && caseM < 18) {
             TextColor(GREEN,BLACK);
             printpos(coTimeM15,"15");
     }
     else if (caseM > 17 && caseM < 23) {
             TextColor(GREEN,BLACK);
             printpos(coTimeM20,"20");
     }
     else if (caseM > 22 && caseM < 28) {
             TextColor(GREEN,BLACK);
             printpos(coTimeM25,"25");
     }
     else if (caseM > 27 && caseM < 33) {
             TextColor(GREEN,BLACK);
             printpos(coTimeM30,"30");
     }
     else if (caseM > 32 && caseM < 38) {
             TextColor(GREEN,BLACK);
             printpos(coTimeM35,"35");
     }
     else if (caseM > 37 && caseM < 43) {
             TextColor(GREEN,BLACK);
             printpos(coTimeM40,"40");
     }
     else if (caseM > 42 && caseM < 48) {
             TextColor(GREEN,BLACK);
             printpos(coTimeM45,"45");
     }
     else if (caseM > 47 && caseM < 53) {
             TextColor(GREEN,BLACK);
             printpos(coTimeM50,"50");
     }
     else if (caseM > 52 && caseM < 58) {
             TextColor(GREEN,BLACK);
             printpos(coTimeM55,"55");
     }
}
void timeH(int caseH){
     COORD coTimeH1,coTimeH2,coTimeH3,coTimeH4,coTimeH5,coTimeH6,coTimeH7,coTimeH8,coTimeH9,coTimeH10,coTimeH11,coTimeH12;
     coTimeH1.Y = 4;
    coTimeH1.X = 42;
    coTimeH2.Y = 7;
    coTimeH2.X = 48;
    coTimeH3.Y = 10;
    coTimeH3.X = 49;
    coTimeH4.Y = 13;
    coTimeH4.X = 48;
    coTimeH5.Y = 16;
    coTimeH5.X = 42;
    coTimeH6.Y = 18;
    coTimeH6.X = 35;
    coTimeH7.Y = 16;
    coTimeH7.X = 28;
    coTimeH8.Y = 13;
    coTimeH8.X = 22;
    coTimeH9.Y = 10;
    coTimeH9.X = 21;
    coTimeH10.Y = 7;
    coTimeH10.X = 22;
    coTimeH11.Y = 4;
    coTimeH11.X = 28;
    coTimeH12.Y = 2;
    coTimeH12.X = 35;
    
    TextColor(LIGHTRED, BLACK);
    printpos(coTimeH1,"1");
    printpos(coTimeH2,"2");
    printpos(coTimeH3,"3");
    printpos(coTimeH4,"4");
    printpos(coTimeH5,"5");
    printpos(coTimeH6,"6");
    printpos(coTimeH7,"7");
    printpos(coTimeH8,"8");
    printpos(coTimeH9,"9");
    printpos(coTimeH10,"10");
    printpos(coTimeH11,"11");
    printpos(coTimeH12,"12");
     switch ( caseH )
            {
            default: 
                printpos(coTimeH1,"1");
                printpos(coTimeH2,"2");
                printpos(coTimeH3,"3");
                printpos(coTimeH4,"4");
                printpos(coTimeH5,"5");
                printpos(coTimeH6,"6");
                printpos(coTimeH7,"7");
                printpos(coTimeH8,"8");
                printpos(coTimeH9,"9");
                printpos(coTimeH10,"10");
                printpos(coTimeH11,"11");
                printpos(coTimeH12,"12");
             case 1:
                  TextColor(GREEN,BLACK);       
                  printpos(coTimeH1,"1");
                  break;
             case 2:
                  TextColor(GREEN,BLACK);       
                  printpos(coTimeH2,"2");
                  break;
             case 3:
                  TextColor(GREEN,BLACK);       
                  printpos(coTimeH3,"3");
                  break;
             case 4:
                  TextColor(GREEN,BLACK);       
                  printpos(coTimeH4,"4");
                  break;
             case 5:
                  TextColor(GREEN,BLACK);       
                  printpos(coTimeH5,"5");
                  break;
             case 6:
                  TextColor(GREEN,BLACK);       
                  printpos(coTimeH6,"6");
                  break;
             case 7:
                  TextColor(GREEN,BLACK);       
                  printpos(coTimeH7,"7");
                  break;
             case 8:
                  TextColor(GREEN,BLACK);       
                  printpos(coTimeH8,"8");
                  break;
             case 9:
                  TextColor(GREEN,BLACK);       
                  printpos(coTimeH9,"9");
                  break;
             case 10:
                  TextColor(GREEN,BLACK);       
                  printpos(coTimeH10,"10");
                  break;
             case 11:
                  TextColor(GREEN,BLACK);       
                  printpos(coTimeH11,"11");
                  break;
             case 12:
                  TextColor(LIGHTGREEN,BLACK);       
                  printpos(coTimeH12,"12");
                  break;
            }
}

void draw(int no, int type) {
     int i;
     COORD coMid, pos;
     coMid.Y = 10;
     coMid.X = 35;
     int endPos;
     if (endPos != pos.X + pos.Y) {
        //system("cls");           
     }
     if (type == 1) {
     switch ( no )
            {
             case 1:
                  pos.Y = 4;
                  pos.X = 42;
                  i = 3;
                  break;
             case 2:
                  pos.Y = 7;
                  pos.X = 48;
                  i = 4;
                  break;
             case 3:
                  pos.Y = 10;
                  pos.X = 49;
                  i = 7;
                  break;
             case 4:
                  pos.Y = 13;
                  pos.X = 48;
                  i = 8;
                  break;
             case 5:
                  pos.Y = 16;
                  pos.X = 42;
                  i = 3;
                  break;
             case 6:
                  pos.Y = 18;
                  pos.X = 35;
                  i = 4;
                  break;
             case 7:
                  pos.Y = 16;
                  pos.X = 28;
                  i = 3;
                  break;
             case 8:
                  pos.Y = 13;
                  pos.X = 22;
                  i = 4;
                  break;
             case 9:
                  pos.Y = 10;
                  pos.X = 21;
                  i = 8;
                  break;
             case 10:
                  pos.Y = 7;
                  pos.X = 22;
                  i = 4;
                  break;
             case 11:
                  pos.Y = 4;
                  pos.X = 28;
                  i = 3;
                  break;
             case 12:
                  pos.Y = 2;
                  pos.X = 35;
                  i = 4;
                  break;
            }
     }
     else if (type == 2){
         if (no > 57 || no < 3) {
                 pos.Y = 4;
                 pos.X = 35;
         }
         else if (no > 2 && no < 8) {
                 pos.Y = 5;
                 pos.X = 40;
         }
         else if (no > 7 && no < 13) {
                 pos.Y = 7;
                 pos.X = 43;
         }
         else if (no > 12 && no < 18) {
                 pos.Y = 10;
                 pos.X = 45;
         }
         else if (no > 17 && no < 23) {
                 pos.Y = 13;
                 pos.X = 43;
         }
         else if (no > 22 && no < 28) {
                 pos.Y = 15;
                 pos.X = 40;
         }
         else if (no > 27 && no < 33) {
                 pos.Y = 16;
                 pos.X = 35;
         }
         else if (no > 32 && no < 38) {
                 pos.Y = 15;
                 pos.X = 29;
         }
         else if (no > 37 && no < 43) {
                 pos.Y = 13;
                 pos.X = 25;
         }
         else if (no > 42 && no < 48) {
                 pos.Y = 10;
                 pos.X = 24;
         }
         else if (no > 47 && no < 53) {
                 pos.Y = 7;
                 pos.X = 27;
         }
         else if (no > 52 && no < 58) {
                 pos.Y = 5;
                 pos.X = 30;
         }
     }
     
     //pos.X = x;
     //pos.Y = y;
     int xstop = 0;
     int ystop = 0;
     while (xstop == 0 || ystop == 0){
         if (coMid.Y < pos.Y && pos.Y != 11) {
            pos.Y = pos.Y - 1;            
         }
         else if (coMid.Y > pos.Y && pos.Y != 9) {
            pos.Y++;   
         }
         else {
            ystop=1;
         }
         if (coMid.X < pos.X && pos.X != 36) {
            pos.X = pos.X - 1;            
         }
         else if (coMid.X > pos.X && pos.X != 34) {
            pos.X++;     
         }
         else {
              xstop=1;     
         }
         SetConsoleCursorPosition(hOut, pos);
         if (i != 0) {
            printf(" ");
            i = i-1;      
         }
         else if (coMid.X == pos.X) {
            printf("|");
         }
         else if (coMid.Y == pos.Y) {
            printf("-");
         }
         else if (coMid.X < pos.X && coMid.Y > pos.Y) {
            printf("/");
         }
         else if (coMid.X < pos.X && coMid.Y < pos.Y) {
            printf("\\");
         }
         else if (coMid.X > pos.X && coMid.Y < pos.Y) {
            printf("/");
         }
         else if (coMid.X > pos.X && coMid.Y > pos.Y) {
            printf("\\");
         }
         endPos = pos.X + pos.Y;
     }
}


